package sax;

import java.io.UnsupportedEncodingException;

import org.xml.sax.HandlerBase;
import org.xml.sax.Parser;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.ParserFactory;

public class SAX1Driver extends HandlerBase implements Driver {
	private Parser parser;

	public void createParser(String parserName,  boolean val, boolean ns) 
		throws Exception {
		parser = ParserFactory.makeParser(parserName);
		parser.setDocumentHandler(this);
		parser.setErrorHandler(this);
		if ( parser instanceof XMLReader ){
			((XMLReader)parser).setFeature( "http://xml.org/sax/features/validation", val);
			((XMLReader)parser).setFeature( "http://xml.org/sax/features/namespaces", ns);
		}
	}
	public void parse(String uri) throws Exception {
		parser.parse(uri);
	}
}
