package sax;

import gd.xml.*;
import java.io.*;
import java.net.URL;

public class TinyXMLDriver implements Driver, XMLResponder {
	//int elms; //
	//int attrs; //
	//int chars; //

	private XMLParser parser;
	private URL url;
	public void createParser(String parserName,  boolean val, boolean ns) 
		throws Exception {
		// all parameters have no effect.
		parser = new XMLParser();
	}
	public void parse(String uri) throws Exception {
		this.url = new URL(uri);
		parser.parseXML(this);
	}
	
	public InputStream getDocumentStream() throws ParseException {
		try {
			return new BufferedInputStream(url.openStream());
		} catch(IOException e) {
			throw new ParseException(e.getMessage());
		}
	}
	

	public void recordDocStart() {
		//elms = attrs = chars = 0; //
	}
	public void recordDocEnd() {
		//System.out.println("("+elms+" elms, "+attrs+" attrs, "+chars+" chars)");//
	}
	public void recordDoctypeDeclaration(String name, String pubID,
										 String sysID) {
	}
	public void recordElementStart(String name, java.util.Hashtable attr) {
		//elms++;//
		//if(attr != null)//
		//	attrs += attr.size();//
	}
	public void recordElementEnd(String name) {
	}
	public void recordCharData(String charData) {
		//chars += charData.length();//
	}
	public void recordComment(String comment) {
	}
	public void recordPI(String name, String value) {
	}
	public InputStream resolveDTDEntity(String name, String pubID,
										String sysID) throws ParseException {
		// don't care pubID.
		try {
			return new BufferedInputStream(new URL(url, sysID).openStream());
		} catch(IOException e) {
			throw new ParseException(e.getMessage());
		}
	}
	public InputStream resolveExternalEntity(String name, String pubID,
											 String sysID)
		throws ParseException {
		// don't care pubID.
		try {
			return new BufferedInputStream(new URL(url, sysID).openStream());
		} catch(IOException e) {
			throw new ParseException(e.getMessage());
		}
	}

	public void recordElementDeclaration(String name, String content) {
	}
	public void recordAttlistDeclaration(String element, String attr,
								  boolean notation, String type,
								  String defmod, String def) {
	}
	public void recordEntityDeclaration(String name, String value,
										String pubID, String sysID,
										String notation) {
	}
	public void recordNotationDeclaration(String name, String pubID,
										  String sysID) {
	}
}
